
import java.util.Calendar;

/**
 * Created by IntelliJ IDEA.
 * Author: Alexandre Koubenski
 *
 *  Sorting      .
 *         .
 *
 * Date: 13.12.2005
 * Time: 9:50:21
 */
public class Sorting {
    /**
     *          .
     *
     * @param args
     */
    public static void main(String[] args) {
        int[] data = Data.vect1;                //       
        boolean printData = true;               //     ?

        sort("bubbleSort", data, printData);     //  ""
        sort("simpleSort", data, printData);     //   
        sort("binInsertSort", data, printData);  //   
        sort("shellSort", data, printData);      //  
        sort("quickSort", data, printData);      //  
        sort("heapSort", data, printData);       //  
        sort("mergeSort", data, printData);      //  
        sort("digitSort", data, printData);      //  
    }

    /**
     *     
     *
     * @param data   -   ( )
     * @param key    -  
     * @return       -     -1,     
     */
    private static int binSearch(int[] data, int key) {
        int l = 0,                 //  
            h = data.length-1;     //  
        while (l < h) {
            // Inv: (l <= h) && " data[k] == key,  l <= k <= h"
            int m = (l + h) / 2;   // ""   (l <= m < h)
            if (data[m] < key) l = m + 1; else h = m;
        }
        return (data[l] == key ? l : -1);
    }

    /**
     *    .
     *
     * @param method   -   -  
     * @param data     -  
     * @param outData  -    
     */
    private static void sort(String method, int[] data, boolean outData) {
        if (outData) System.out.println("Data generating...");
        Data.genData(data);   //    
        if (outData) {
            System.out.println("Before sorting:");
            Data.output(data);
        }

        try {
            long tm = Calendar.getInstance().getTimeInMillis();
            //   
            Sorting.class.getMethod(method, new Class[] { int[].class }).invoke(null, new Object[] { data });
            //      
            System.out.println("After " + method + " sorting (elasped time is " +
                    (Calendar.getInstance().getTimeInMillis() - tm) + "):");
            //   
            if (outData) Data.output(data);
        } catch (Exception x) {
            x.printStackTrace();
        }
    }

    /**
     *   "".
     *  :
     *    - ;
     *    - ;
     *    -  " ";
     *    -       ;
     *    -     ,    
     *  :
     *    -      .
     *   :
     *    -    - (n);
     *    -         - O(n*n);
     *    -    - O(n*n)
     *
     * @param data   inout -     
     */
    public static void bubbleSort(int[] data) {
        int n = data.length;
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < n-i; j++) {
                if (data[j] > data [j+1]) {
                    int tmp = data[j];
                    data[j] = data[j+1];
                    data[j+1] = tmp;
                }
            }
        }
    }

    /**
     *    .
     *  :
     *    - ;
     *    - ;
     *    -  " ";
     *    -      ;
     *    -     ,    
     *  :
     *    -      .
     *   :
     *    -    - (n);
     *    -         - O(n*n);
     *    -    - O(n*n)
     *
     * @param data   inout -     
     */
    public static void simpleSort(int[] data) {
        simpleSort(data, 0, data.length-1);
    }

    /**
     *       
     *
     * @param data  - ,  ,  
     * @param from  -    
     * @param to    -    
     */
    private static void simpleSort(int[] data, int from, int to) {
        int i, j;
        for (i = from+1; i <= to; i++) {
            int c = data[i];
            for (j = i-1; j >= from && data[j] > c; j--) {
                data[j+1] = data[j];
            }
            data[j+1] = c;
        }
    }

    /**
     *    .     
     *      .
     *   (     ):
     *    -         ;
     *   (     ):
     *    -  ;
     *   :
     *    -    - (n);
     *    -         - O(n*n);
     *    -    - O(n*n)
     *
     * @param data   inout -     
     */
    public static void binInsertSort(int[] data) {
        int n = data.length;      //  
        for (int i = 1; i < n; i++) {
            int c = data[i];      //  
            //       c
            int low = 0, high = i;
            // Inv : (low <= high) &&   c -  data[low:high]
            while (low < high) {
                int m = (low+high) >> 1;
                // low <= m < high
                if (data[m] < c) low = m+1; else high = m;
            }
            //    - low
            //      .
            for (int j = i-1; j >= low; j--) {
                data[j+1] = data[j];
            }
            //     
            data[low] = c;
        }
    }

    /**
     *   .
     *  :
     *    - ;
     *    -  " ";
     *    -        ;
     *  :
     *    -  ;
     *    -   .
     *   :
     *    -    - (n);
     *    -         - ?;
     *    -    - ?
     *
     * @param data   inout -     
     */
    public static void shellSort(int[] data) {
        int n = data.length;    //  
        int step = n;           //    
        do {
            int i, j;
            //   
            step = step / 3 + 1;
            //       
            for (i = step; i < n; i++) {
                int c = data[i];
                for (j = i-step; j >= 0 && data[j] > c; j -= step) {
                    data[j+step] = data[j];
                }
                data[j+step] = c;
            }
        } while (step != 1);
    }

    /**
     *   "".
     *  :
     *    -  " ";
     *    -       ;
     *  :
     *    -  .
     *    -     ,    
     *   :
     *    -    - (n * log(n));
     *    -         - O(n * log(n));
     *    -    - O(n*n)
     *
     * @param data   inout -     
     */
    public static void quickSort(int[] data) {
        quickSort(data, 0, data.length-1);
    }

    /**
     *       "" .
     *  ,         
     *
     * @param data    - inout -  
     * @param from    -    
     * @param to      -    
     */
    private static void quickSort(int[] data, int from, int to) {
        if (to-from < 50)
            //       
            simpleSort(data, from, to);
        else {
            int c = data[from];    //   
            //         c.
            int low = from, high = to+1;
            // Inv: (low <= high) && data[from:(low-1)] <= c && data[high:to] >= c
            while (low < high) {
                while (low < high && data[--high] >= c) ;
                data[low] = data[high];
                while (low < high && data[++low] <= c) ;
                data[high] = data[low];
            }
            //     
            data[low] = c;
            //       
            quickSort(data, from, low-1);
            quickSort(data, low+1, to);
        }
    }

    /**
     *   .
     *  :
     *    -  " ";
     *    -          ;
     *  :
     *    -  ;
     *    -  ;
     *    -        .
     *   :
     *    -    - (n * log(n));
     *    -         - O(n * log(n));
     *    -    - O(n * log(n))
     *
     * @param data   inout -     
     */
    public static void heapSort(int[] data) {
        int n = data.length;   //  

        //  
        buildPyramid:
        for (int i = 1; i < n; i++) {
            //  data[0:i-1]   ;
            //     data[i]
            int c = data[i];   // "" 
            int p = i, q;      //   ""   
            do {
                q = p;
                if ((p = (q-1) >> 1) >= 0 && data[p] < c) {
                    data[q] = data[p];
                } else {
                    data[q] = c;
                    continue buildPyramid;
                }
            } while(true);
        }

        //   
        meltPyramid:
        for (int i = n-1; i > 0; i--) {
            //       ,   
            //    ""
            int c = data[i];
            data[i] = data[0];
            int q, p = 0;      //   
            do {
                q = p;
                p = (q << 1) | 1;
                if (p >= i) {
                    //    
                    data[q] = c;
                    continue meltPyramid;
                }
                if (p < i-1 && data[p+1] > data[p]) p++;
                if (data[p] > c) {
                    data[q] = data[p];
                } else {
                    data[q] = c;
                    continue meltPyramid;
                }
            } while (true);
        }
    }

    /**
     *     
     *
     * @param a  -  
     * @param b  -  
     * @return   -  
     */
    public static int[] merge(int[] a, int[] b) {
        int na = a.length, nb = b.length, nc;
        int[] c = new int[nc = na + nb];
        int ia = 0, ib = 0, ic = 0;
        while (ia < na && ib < nb) {
            if (a[ia] < b[ib])
                c[ic++] = a[ia++];
            else
                c[ic++] = b[ib++];
        }
        while (ia < na) c[ic++] = a[ia++];
        while (ib < nb) c[ic++] = b[ib++];
        return c;
    }

    /**
     *    ( ).
     *  :
     *    - ;
     *    -   ;
     *  :
     *    -  ;
     *    -     n;
     *   :
     *    -    - (n * log(n));
     *    -         - O(n * log(n));
     *    -    - O(n * log(n))
     *
     * @param data   inout -     
     */
    public static void mergeSort(int[] data) {
        int n = data.length;          //  
        int[] altData = new int[n];   //  
        int[] from = data,            //  ""  ""  
              to = altData;
        int ml = 1;                   //   
        do {
            int start = 0;
            while(start < n) {
                //   from[start:(start+ml-1)]  from[(start+ml):(start+2*ml-1)]
                //  to[start:(start+2*m-1)]
                mergeSection(
                        from, start, Math.min(start+ml, n),
                        from, Math.min(start+ml, n), Math.min(start+(ml<<1), n),
                        to, start);
                start += (ml << 1);
            }
            //   
            int[] interm = from; from = to; to = interm;
        } while ((ml <<= 1) < n);
        //       " ",    " "
        if (from != data) {
            mergeSection(from, 0, n, from, n, n, data, 0);
        }
    }

    /**
     *       
     * @param from1  -   
     * @param l1     -    
     * @param h1     -    ,   1
     * @param from2  -   (,   )
     * @param l2     -    
     * @param h2     -    ,   1
     * @param to     -  
     * @param l3     -    
     */
    private static void mergeSection(
            int[] from1, int l1, int h1,
            int[] from2, int l2, int h2,
            int[] to, int l3) {
        while (l1 < h1 && l2 < h2) {
            if (from1[l1] < from2[l2]) {
                to[l3++] = from1[l1++];
            } else {
                to[l3++] = from2[l2++];
            }
        }
        while(l1 < h1) to[l3++] = from1[l1++];
        while(l2 < h2) to[l3++] = from2[l2++];
    }

    /**
     *   .
     *  :
     *    - ;
     *    -     ,     "";
     *  :
     *    -     n;
     *   :
     *    -    - (n);
     *    -         - O(n);
     *    -    - O(n)
     *
     * @param data   inout -     
     */
    public static void digitSort(int[] data) {
        int n = data.length;        //  
        int[] data2 = new int[n];   //  
        for (int step = 0; step < 8; step++) {  // Step -  ""
            //  ""     
            countSort(data, step, data2);
            //    
            int[] temp = data; data = data2; data2 = temp;
        }
    }

    /**
     *   .
     *         16- 
     *
     * @param src     -  
     * @param nDig    -   (   )
     * @param dest    -  
     */
    private static void countSort (int[] src, int nDig, int[] dest) {
        int n = src.length;          //  
        int[] count = new int[16];   //    
        // 1. 
        nDig <<= 2;
        for (int i = 0; i < n; i++) {
            count[(src[i] & (0xF << nDig)) >> nDig]++;
        }
        // 2. 
        for (int i = 1; i < 16; i++) {
            count[i] += count[i-1];
        }
        // 3. 
        for (int i = n-1; i >= 0; i--) {
            dest[--count[(src[i] & (0xF << nDig)) >> nDig]] = src[i];
        }
    }
}
